import java.util.Random;
public abstract class Gene implements java.lang.Comparable{
		 int N; // number of items in the permutation
		 float fitness;// this must be evaluated when gene is created 
		 Evaluator E;
		 int hash=0;
		 abstract int[] getPermutation();
		 abstract Gene mutate(); 
		 abstract Gene crossover(Gene another);
		 String permutationString(){
			 int[] p=getPermutation();
			 String s="";
			 for(int i= 0;i<N;i++)s += p[i]+" ";
			 return s;
		 }
		 public int compareTo(Object o){
			 if(o instanceof Gene){
				 Gene g = (Gene)o;
				 if (fitness <g.fitness) return -1;
				 if (fitness > g.fitness) return 1;
				 if(equals(g))return 0;
				 return -1;
			}
			return 1;
		}
}
class Permutor1 extends Gene{
	static boolean showwork=false;
	byte[][] genome ;
	static Random randomGenerator = new Random();
	 int J,L;  
	 int[] permutation=null;
	Permutor1 (int n, Evaluator e){N=n;E=e;
	  int i=1;int j=1;
	  while (i<n){i=i*2;j++;}J=j-1;L=i;
	  genome = new byte[J][L];
	  hash=hashgene();
	  fitness=e.evaluate(getPermutation());
	}
	public String toString(){
		String heading=permutationString()+ " fitness="+fitness+"\n" ;
		for(int j=0;j<J;j++)
		{
			for(int i=0;i<L;i++) heading += genome[j][i];
			heading+="\n";
		}
		return heading;
	}
	Permutor1(Permutor1 p){
		N=p.N;E=p.E;genome= p.genome.clone();fitness=p.fitness;
		 L=p.L;J=p.J;
		for (int  i=0;i<J;i++) genome[i]=genome[i].clone();
	}
	
	int[] getPermutation(){
		if(permutation==null){
		 int[] mine = new int[L];
		 for(int i=0;i<L;i++) mine[i]=i;
		 for(int j=0;j<J;j++)
		 { 
		 recursiveswap(mine,genome[j],(int)Math.pow(2,j));
		 
		 }
		 permutation=mine;
		}
		return permutation;
	}
	 
	void recursiveswap(int [] perm, byte[] gene, int offset){
			int genescan=0;
			int permscan=0;
			int permstep= L/2;
			while(permstep>=1){
				permscan=0; 
				while((permscan+permstep+permstep-1)<L){
					int doit = gene[genescan];
					if(showwork){
						System.out.println("permstep="+permstep+"permscan="+permscan+"genescan="+genescan);
						for(int i=0;i<L;i++)System.out.print(perm[i]);
						System.out.println();
						for(int i=0;i<L;i++)System.out.print(gene[i]);
						System.out.println();
						for(int i=0;i<genescan;i++)System.out.print(" ");
						System.out.println("^");
					}
					genescan++;
					if(doit>0){// swap the entries
						for(int j=0;j<permstep;j++){
							int temp = perm[(offset+permscan+j)%L];
							 
							perm[(offset +permscan+j)%L] = perm [(offset+permscan+permstep+j)%L];
							perm[(offset+permscan+ permstep+j)%L]=temp;
						}
						 
					}
					if(showwork){
						for(int i=0;i<L;i++)System.out.print(perm[i]);
						System.out.println();
					}
					permscan+= (2*permstep);
				}
				permstep = permstep / 2;
			}
	}
	Gene mutate(){
		Permutor1 p = new Permutor1(this);
		for(int i =0;i<J;i++)
		  p.genome[i][ randomGenerator.nextInt(L)] ^= 1;
		p.fitness=E.evaluate(p.getPermutation());
	    p.hash=p.hashgene();
		return p;
		
	}
	int hashgene(){
		int h=312;
		for(byte[] g : genome)for(byte b : g)h = (h+b)*7;
		return h;
	}
	Gene crossover(Gene another){
		    Permutor1 p2=this;
			Permutor1 p = new Permutor1(this);
			if (another instanceof Permutor1) p2=(Permutor1)another;
			int pos = randomGenerator.nextInt(J);
			for(int i=pos;i<J;i++)p.genome[i]=p2.genome[i].clone();
			p.fitness = E.evaluate(p.getPermutation());
			p.hash=p.hashgene();
			return p;
	}	
}
